<?php

namespace hkpost\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MailTrackingDetailwSEResult StructType
 * @subpackage Structs
 */
class MailTrackingDetailwSEResult extends AbstractStructBase
{
    /**
     * The allMTMs
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \hkpost\StructType\MailTrackMilestone
     */
    public $allMTMs;
    /**
     * The allTrackingDetail
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \hkpost\ArrayType\ArrayOf_tns1_TrackingDetail
     */
    public $allTrackingDetail;
    /**
     * The destination
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $destination;
    /**
     * The error_code
     * @var int
     */
    public $error_code;
    /**
     * The itemNo
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $itemNo;
    /**
     * Constructor method for MailTrackingDetailwSEResult
     * @uses MailTrackingDetailwSEResult::setAllMTMs()
     * @uses MailTrackingDetailwSEResult::setAllTrackingDetail()
     * @uses MailTrackingDetailwSEResult::setDestination()
     * @uses MailTrackingDetailwSEResult::setError_code()
     * @uses MailTrackingDetailwSEResult::setItemNo()
     * @param \hkpost\StructType\MailTrackMilestone $allMTMs
     * @param \hkpost\ArrayType\ArrayOf_tns1_TrackingDetail $allTrackingDetail
     * @param string $destination
     * @param int $error_code
     * @param string $itemNo
     */
    public function __construct(\hkpost\StructType\MailTrackMilestone $allMTMs = null, \hkpost\ArrayType\ArrayOf_tns1_TrackingDetail $allTrackingDetail = null, $destination = null, $error_code = null, $itemNo = null)
    {
        $this
            ->setAllMTMs($allMTMs)
            ->setAllTrackingDetail($allTrackingDetail)
            ->setDestination($destination)
            ->setError_code($error_code)
            ->setItemNo($itemNo);
    }
    /**
     * Get allMTMs value
     * @return \hkpost\StructType\MailTrackMilestone|null
     */
    public function getAllMTMs()
    {
        return $this->allMTMs;
    }
    /**
     * Set allMTMs value
     * @param \hkpost\StructType\MailTrackMilestone $allMTMs
     * @return \hkpost\StructType\MailTrackingDetailwSEResult
     */
    public function setAllMTMs(\hkpost\StructType\MailTrackMilestone $allMTMs = null)
    {
        $this->allMTMs = $allMTMs;
        return $this;
    }
    /**
     * Get allTrackingDetail value
     * @return \hkpost\ArrayType\ArrayOf_tns1_TrackingDetail|null
     */
    public function getAllTrackingDetail()
    {
        return $this->allTrackingDetail;
    }
    /**
     * Set allTrackingDetail value
     * @param \hkpost\ArrayType\ArrayOf_tns1_TrackingDetail $allTrackingDetail
     * @return \hkpost\StructType\MailTrackingDetailwSEResult
     */
    public function setAllTrackingDetail(\hkpost\ArrayType\ArrayOf_tns1_TrackingDetail $allTrackingDetail = null)
    {
        $this->allTrackingDetail = $allTrackingDetail;
        return $this;
    }
    /**
     * Get destination value
     * @return string|null
     */
    public function getDestination()
    {
        return $this->destination;
    }
    /**
     * Set destination value
     * @param string $destination
     * @return \hkpost\StructType\MailTrackingDetailwSEResult
     */
    public function setDestination($destination = null)
    {
        // validation for constraint: string
        if (!is_null($destination) && !is_string($destination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($destination)), __LINE__);
        }
        $this->destination = $destination;
        return $this;
    }
    /**
     * Get error_code value
     * @return int|null
     */
    public function getError_code()
    {
        return $this->error_code;
    }
    /**
     * Set error_code value
     * @param int $error_code
     * @return \hkpost\StructType\MailTrackingDetailwSEResult
     */
    public function setError_code($error_code = null)
    {
        // validation for constraint: int
        if (!is_null($error_code) && !is_numeric($error_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($error_code)), __LINE__);
        }
        $this->error_code = $error_code;
        return $this;
    }
    /**
     * Get itemNo value
     * @return string|null
     */
    public function getItemNo()
    {
        return $this->itemNo;
    }
    /**
     * Set itemNo value
     * @param string $itemNo
     * @return \hkpost\StructType\MailTrackingDetailwSEResult
     */
    public function setItemNo($itemNo = null)
    {
        // validation for constraint: string
        if (!is_null($itemNo) && !is_string($itemNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($itemNo)), __LINE__);
        }
        $this->itemNo = $itemNo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \hkpost\StructType\MailTrackingDetailwSEResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
